; *************************************************************************************************
; *
; *	Title:	HELP.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the code for activating a help function
; *
; *************************************************************************************************

	include	mouse.inc


HELP_ENABLED		equ	(1 shl 0)


.data

Help_Function_Ptr	dd	0
Help_Flags		dw	0	; b0:enabled, 
Help_Key		dw	0


.code
; *************************************************************************************************
; *
; *	void INIT_HELP( void (*FUNCTION)( void ), us KEY )
; *	Initializes the help function
; *
; *	Given:
; *		FUNCTION -> function to call when help key pressed
; *		KEY = help key
; *
; *	Returns:
; *		nothing
; *
; *************************************************************************************************
if @Datasize
init_help proc uses ds, function:dword, key:word
	mov	ax, @Data
	mov	ds, ax
else
init_help proc
endif

	mov	ax, key
	mov	Help_Key, ax
	mov	ax, word ptr function
	mov	bx, word ptr function+2
	mov	word ptr Help_Function, ax
	mov	word ptr Help_Function+2, bx

	and	Help_Flags, not HELP_ENABLED
	or	ax, bx
	jz	@F
	or	Help_Flags, HELP_ENABLED

@@:	ret

init_help endp


; *************************************************************************************************
; *
; *	void ENABLE_HELP( void )
; *	Enables the help key
; *
; *	Given:
; *		nothing
; *
; *	Returns:
; *		nothing
; *
; *************************************************************************************************
if @Datasize
enable_help proc uses ds
	mov	ax, @Data
	mov	ds, ax
else
enable_help proc
endif

	and	Help_Flags, not HELP_ENABLED
	mov	ax, word ptr Help_Function
	or	ax, word ptr Help_Function+2

	jz	@F
	or	Help_Flags, HELP_ENABLED

@@:	ret

enable_help endp


; *************************************************************************************************
; *
; *	void DISABLE_HELP( void )
; *	Disables the help key
; *
; *	Given:
; *		nothing
; *
; *	Returns:
; *		nothing
; *
; *************************************************************************************************
if @Datasize
disable_help proc uses ds
	mov	ax, @Data
	mov	ds, ax
else
disable_help proc
endif

	and	Help_Flags, not HELP_ENABLED
	ret

disable_help endp

	end



