; *************************************************************************************************
; *
; *	Title:	MARROW.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the code and data for setting the mouse cursor to an arrow
; *
; *************************************************************************************************

	include	mouse.inc


.data
Arrow_Cursor	label	word
	dw	0011111111111111b
	dw	0001111111111111b
	dw	0000111111111111b
	dw	0000011111111111b
	dw	0000001111111111b
	dw	0000000111111111b
	dw	0000000011111111b
	dw	0000000001111111b
	dw	0000000000111111b
	dw	0000000000011111b
	dw	0000000111111111b
	dw	0001000011111111b
	dw	0011000011111111b
	dw	1111100001111111b
	dw	1111100001111111b
	dw	1111110000111111b

	dw	0000000000000000b
	dw	0100000000000000b
	dw	0110000000000000b
	dw	0111000000000000b
	dw	0111100000000000b
	dw	0111110000000000b
	dw	0111111000000000b
	dw	0111111100000000b
	dw	0111111110000000b
	dw	0111111111000000b
	dw	0111110000000000b
	dw	0100011000000000b
	dw	0000011000000000b
	dw	0000001100000000b
	dw	0000001100000000b
	dw	0000000110000000b


	public	_Current_Mouse_Pointer
_Current_Mouse_Pointer	dw	0,0
			dw	0,0		; HOT_X, HOT_Y
.code

	public	all_mouse_cursors_

; *************************************************************************************************
; *
; *	int MOUSE_ARROW( void )
; *	Sets the graphic cursor to the standard arrow
; *
; *	Given:
; *		nothing
; *
; *	Returns:
; *		Mouse cursor set to standard arrow
; *
; *************************************************************************************************
mouse_arrow proc

	push	ds
	mov	ax, @Data
	mov	ds, ax
	mov	dx, offset Arrow_Cursor
	or	bx, -1			; Make hot spot just above and to the left
	mov	cx, bx

all_mouse_cursors_::
	mov	ax, @Data
	mov	es, ax
	cmp	es:_Mouse_Button_Count, 0
	jz	@F

	mov	es:_Current_Mouse_Pointer, dx
	mov	es:_Current_Mouse_Pointer+2, ds
	mov	es:_Current_Mouse_Pointer+4, bx
	mov	es:_Current_Mouse_Pointer+6, cx
	mov	ax, ds
	mov	es, ax
	MOUSE	9			; MOUSE Set Graphics Cursor Block

@@:	pop	ds
	ret

mouse_arrow endp


; *************************************************************************************************
; *
; *	void FAR *MOUSE_GET_POINTER( int FAR *HOT_X, int FAR *HOT_Y )
; *	Gets the a pointer to the current mouse cursor
; *
; *	Given:
; *		nothing
; *
; *	Returns:
; *		Pointer to the current mouse pointer
; *
; *************************************************************************************************
mouse_get_pointer proc uses ds, hot_x:dword, hot_y:dword

	mov	ax, @Data
	mov	ds, ax
	mov	ax, _Current_Mouse_Pointer
	mov	dx, _Current_Mouse_Pointer+2
	les	bx, hot_x
	mov	cx, es
	or	cx, bx
	jz	@F
	mov	cx, _Current_Mouse_Pointer+4
	mov	es:[bx], cx

@@:	les	bx, hot_y
	mov	cx, es
	or	cx, bx
	jz	@F
	mov	cx, _Current_Mouse_Pointer+6
	mov	es:[bx], cx

@@:	ret

mouse_get_pointer endp

	end


