; *************************************************************************************************
; *
; *	Title:	MBOUNDS.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the functions for setting the movement boundaries for the mouse
; *
; *************************************************************************************************

	include	mouse.inc


.code
; *************************************************************************************************
; *
; *	int MOUSE_SET_BOUNDS( int X1, int Y1, int X2, int Y2 )
; *	Sets the X,Y boundaries for the mouse cursor
; *
; *	Given:
; *		X1,Y1 = upper left corner of the boundary
; *		X2,Y2 = lower right corner of the boundary
; *		If any of the bounds are negative, they will be ignored
; *
; *	Returns:
; *		Always 0
; *
; *************************************************************************************************
mouse_set_bounds proc, x1:word, y1:word, x2:word, y2:word

	mov	cx, x1
	mov	dx, x2
	test	ch, 1 shl 7		; See if negative
	jnz	@F
	test	dh, 1 shl 7		; See if negative
	jnz	@F
	MOUSE	7

@@:	mov	cx, y1
	mov	dx, y2
	test	ch, 1 shl 7		; See if negative
	jnz	@F
	test	dh, 1 shl 7		; See if negative
	jnz	@F

	MOUSE	8

@@:	xor	ax, ax
	ret

mouse_set_bounds endp

	end


