; *************************************************************************************************
; *
; *	Title:	MGETXY.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the functions for getting current mouse position and button status
; *
; *************************************************************************************************

	include	mouse.inc


.code
; *************************************************************************************************
; *
; *	int MOUSE_GETXY( int *X, int *Y )
; *	Gets the current mouse location
; *
; *	Given:
; *		X,Y -> current mouse coordinates
; *		If NULL, will not be set
; *
; *	Returns:
; *		Current button status
; *		_Mouse_X,_Mouse_Y set to current mouse position
; *
; *************************************************************************************************
if @Datasize
mouse_getxy proc uses ds, x:ptr, y:ptr

	mov	ax, @Data
	mov	ds, ax
else
mouse_getxy proc, x:ptr, y:ptr
endif
	xor	ax, ax
	cmp	_Mouse_Button_Count, ax
	jz	done

	MOUSE	3
	mov	_Mouse_X, cx
	mov	_Mouse_Y, dx
	push	bx
if @Datasize
	lds	bx, x
	mov	ax, ds
	or	ax, bx
else
	mov	bx, x
	or	bx, bx
endif
	jz	@F
	mov	[bx], cx
@@:
if @Datasize
	lds	bx, y
	mov	ax, ds
	or	ax, bx
else
	mov	bx, y
	or	bx, bx
endif
	jz	@F
	mov	[bx], dx
@@:	pop	ax
done:	ret

mouse_getxy endp

	end




