; *************************************************************************************************
; *
; *	Title:	MINIT.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the code for initializing the mouse library and functions
; *
; *************************************************************************************************

_MINIT_ASM_	equ	1
	include	mouse.inc


.data

	public	_Mouse_Button_Count

_Mouse_Button_Count	dw	0		; Number of mouse buttons


.code
if @Codesize
	extern	mouse_getxy:far
else
	extern	mouse_getxy:near
endif
; *************************************************************************************************
; *
; *	int MOUSE_INIT( void )
; *	Initializes the mouse access and global variables
; *
; *	Given:
; *		nothing
; *
; *	Returns:
; *		0 if the mouse is installed and ready to go
; *
; *************************************************************************************************
if @Datasize
mouse_init proc uses ds
else
mouse_init proc
endif

	mov	_Mouse_Button_Count, 0	; Clear the number of buttons
	MOUSE	0
	inc	ax			; See if we have a mouse
	jnz	@F			; Quit with error if we don't

	mov	_Mouse_Button_Count, bx
	xor	ax, ax
	push	ax
	push	ax
if @Datasize
	push	ax
	push	ax
endif
	call	mouse_getxy
if @Datasize
	add	sp, 8
else
	add	sp, 4
endif
	xor	ax, ax
@@:	ret

mouse_init endp

	end

