; *************************************************************************************************
; *
; *	Title:	MSTATUS.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the functions to get the current button statistics
; *
; *************************************************************************************************

	include	mouse.inc


.code
; *************************************************************************************************
; *
; *	int MOUSE_GET_STATUS( MOUSE_STATUS_T FAR *DX:AX, int BX )
; *	Gets the current press and release statistics for a mouse button
; *
; *	Given:
; *		DX:AX -> structure to fill, if NULL nothing happens
; *		BX = mouse button to get statistics for
; *
; *	Returns:
; *		Current mouse button status and structure is filled
; *
; *************************************************************************************************
mouse_get_status proc uses di si, status_ptr:dword, button:word

	mov	bx, button
	MOUSE	5			; Get button press information
	les	di, status_ptr
	mov	es, si
	or	si, di
	jz	@F
	mov	es:[di].MOUSE_STATUS_S.press_count, bx
	mov	es:[di].MOUSE_STATUS_S.press_x, cx
	mov	es:[di].MOUSE_STATUS_S.press_y, dx

	mov	bx, button
	MOUSE	6			; Get button press information
	mov	es:[di].MOUSE_STATUS_S.release_count, bx
	mov	es:[di].MOUSE_STATUS_S.release_x, cx
	mov	es:[di].MOUSE_STATUS_S.release_y, dx
	mov	es:[di].MOUSE_STATUS_S.status, ax

@@:	ret

mouse_get_status endp

	end
