; *************************************************************************************************
; *
; *	Title:	MWAIT.ASM
; *	Copyright (c) January 1993, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains all the functions to wait for a mouse event
; *
; *************************************************************************************************

	include	mouse.inc


.code

if @Codesize
	extern	clear_events:far
else
	extern	clear_events:near
endif

; *************************************************************************************************
; *
; *	int MOUSE_WAIT( int BMASK, int RESULT )
; *	Waits for the mouse status to equal RESULT after masked with BMASK
; *
; *	Given:
; *		BMASK = mask to place upon the mouse status
; *		RESULT = status result to exit after it is masked
; *
; *	Returns:
; *		Current mouse button status and structure is filled
; *
; *************************************************************************************************
if @Datasize
mouse_wait proc uses ds, bmask:word, result:word

	mov	ax, @Data
	mov	ds, ax
else
mouse_wait proc, bmask:word, result:word
endif

	xor	ax, ax
	cmp	_Mouse_Button_Count, ax
	jz	done

@@:	MOUSE	3
	and	bx, bmask		; Mask off the current status
	cmp	bx, result
	jne	@B

	push	bx
	call	clear_events
	pop	ax

done:	ret

mouse_wait endp

	end

