; *************************************************************************************************
; *
; *	Title:	PEVENT.ASM
; *	Copyright (c) March 1994, Ryu Consulting
; *	Written by Rahner James
; *
; *	This file contains the code to access the event variables
; *
; *************************************************************************************************

	include	event.inc

.data
	extern	_Event_Global:dword, __Mouse_Enabled:byte
	extern	___Cursor_X:dword, ___Cursor_Y:dword

Old_Mouse_X	dw	-1
Old_Mouse_Y	dw	-1


.code
	extern	gr_put_cursor_:near


; *************************************************************************************************
; *
; *	int GET_EVENT( EVENT_T *EAX )
; *	Gets the next available event
; *
; *	Given:
; *		EAX -> event packet to fill
; *
; *	Returns:
; *		0 if all OK
; *
; *************************************************************************************************
get_event_ proc uses edi ebx ecx

	mov	edi, _Event_Global			; EDI -> global data variables
	cmp	__Mouse_Enabled, 0
	jz	short get10_event

	mov	ebx, dword ptr [edi].ET_S.x		; See if there is a difference
	cmp	dword ptr Old_Mouse_X, ebx
	je	short get10_event
	mov	dword ptr Old_Mouse_X, ebx

	mov	ebx, eax
	mov	ecx, edx

	xor	eax, eax
	mov	edx, eax
	mov	ax, [edi].ET_S.x
	mov	dx, [edi].ET_S.y
	call	gr_put_cursor_

	mov	edx, ecx
	mov	eax, ebx

get10_event:
	xor	ebx, ebx				; Clear MSWord of EBX
	cmp	[edi].ET_S.total_queued_events, bx	; See if we have any
	jz	short derr_event			; Quit if not

	mov	bl, byte ptr [edi].ET_S.first_queued_event	; EBX = offset into the event table of the next queued event
	shl	ebx, 4
	lea	ebx, [edi+ebx].ET_S.event_packets		; EBX -> event packet

; *
; * Move the event packet to the waiting packet
; *
	mov	ecx, [ebx+4]
	mov	[eax+4], ecx
	mov	ecx, [ebx+8]
	mov	[eax+8], ecx
	mov	ecx, [ebx+12]
	mov	[eax+12], ecx
	mov	ecx, [ebx]				; CL = event type
	mov	[eax], ecx

; *
; * Update the event queue
; *
	add	dword ptr [edi].ET_S.total_free_events, 10001h	; Increment total free count and first queued at same time
	mov	byte ptr [edi].ET_S.first_queued_event+1, 0	; Clear the MSWord of both
	dec	[edi].ET_S.total_queued_events

	or	cl, cl					; See if it's a NULL event
	jz	get10_event				; Get the next in line, if it's NULL

	cmp	cl, 2					; See if keyboard
	je	short get30_event
get20_event:
	xor	eax, eax				; Signal that we got a good packet
done:	ret

derr_event:
	mov	[eax].MOUSE_EVT.etype, 0		; Assume no event before its time
	mov	eax, -4020				; Signal no event available
	jmp	done

; *
; * Get the key
; *
get30_event:
	mov	ecx, eax		; ECX -> receiving event packet

	mov	ah, 11h			; BIOS Get Keyboard Status command
	int	16h
	jz	short get40_event

; *
; * Key was waiting, let's see if it's extended or not
; *
	cmp	ah, 85h			; See if F11
	je	short do_extended
	cmp	ah, 86h			; See if F12
	je	short do_extended

	mov	ah, 0			; BIOS Read Character from Keyboard
@@:	int	16h
	mov	word ptr [ecx].MOUSE_EVT.ascii, ax
	jmp	get20_event

do_extended:
	mov	ah, 10h
	jmp	@B

get40_event:
	mov	eax, ecx
	jmp	get10_event

get_event_ endp



do_ints_ proc uses ecx

	mov	ecx, eax
@@:	cli
	nop
	sti
	loop	@B

	ret

do_ints_ endp


	end
