#include <stdlib.h>
#include <user.h>
#include <event.h>


MOUSE_STATUS_T	Mstat;
EVENT_T			Evt;
char			Main_Loop_Continue = 1;
TIME_HDR_T FAR *Tmr1;
TIME_HDR_T FAR *Tmr2;


NODE_T	Node;


main()
{
	int	nhandle, sap_handle, wan_handle, spx_handle=-1;
	uc	buffer[20];
	IPX_STATUS_T cc;

	print( "Test the event functions" );

/*
** Initialize the library sections
*/
	mouse_init();
	ipx_init( 30 );
	start_events( 100 );

/*
** Initialize some structures
*/
	Node.network = 0;
	Node.node[0] =
	Node.node[1] =
	Node.node[2] =
	Node.node[3] =
	Node.node[4] =
	Node.node[5] = 0;
	Node.socket = 0x5204;		// SAP socket
	nhandle = ipx_open_connection( &Node, 5, 0, 0 );

	Node.network = 0;
	Node.node[0] =
	Node.node[1] =
	Node.node[2] =
	Node.node[3] =
	Node.node[4] =
	Node.node[5] = 0xFF;
	Node.socket = 0x5252;		// Any old packet
	wan_handle = ipx_open_connection( &Node, 5, 0, 1<<4 );

	Tmr1 = tmr_create_extended( 18*5, NULL, NULL, 20, 0 );
	Tmr2 = tmr_create( 0, 0 );
	print( "\nTmr1 = %08lX, Tmr2 = %08lX", Tmr1, Tmr2 );

/*
** Start looping
*/
	while ( Main_Loop_Continue )
	{
		if ( get_event(&Evt) )
			continue;
		print( "\nGot an event %04X", Evt.type );

/*
** Process any keyboard input
*/
		if ( Evt.type == EVT_KEYBOARD )
		{
			print( ", ascii = %c, scan = %02X, state = %04X", Evt.kbd.ascii, Evt.kbd.scan, Evt.kbd.state );
			switch ( Evt.kbd.ascii )
			{
				case ESC:
					Main_Loop_Continue = 0;
					break;

				case '1':
					tmr_start( Tmr1, 18*5 );
					break;

				case '2':
					tmr_start( Tmr2, 18*12 );
					break;

				case '3':		// Send out a SAP
					Node.network = 0;
					Node.node[0] =
					Node.node[1] =
					Node.node[2] =
					Node.node[3] =
					Node.node[4] =
					Node.node[5] = 0xFF;
					Node.socket = 0x5204;		// SAP socket
					if ( (sap_handle=ipx_open_connection(&Node,0,0,0)) >= 0 )
					{
						buffer[0] = 0;
						buffer[1] = 1;
						buffer[2] = 0;
						buffer[3] = 4;
						ipx_write_packet( sap_handle, buffer, 4, &cc );
						while ( cc.inUseFlag )
							;
						ipx_close_connection( sap_handle );
					}
					print( "\nSent SAP request" );
					break;

				case '4':		// Send out a WAN broadcast
					print( "\nSending a WAN broadcast" );
					buffer[0] = 1;
					buffer[1] = 2;
					buffer[2] = 3;
					buffer[3] = 4;
					buffer[4] = 5;
					ipx_write_packet( wan_handle, buffer, 5, &cc );
					while ( cc.inUseFlag )
						;
					print( ", sent successfully" );
					break;

				case '5':		// Listen for a connection
					if ( spx_handle != -1 )
					{
						beep();
						break;
					}
					print( "\nSetting up listen for SPX connection ..." );
					Node.network = 0;
					Node.node[0] =
					Node.node[1] =
					Node.node[2] =
					Node.node[3] =
					Node.node[4] =
					Node.node[5] = 0;
					Node.socket = 0x5352;
					spx_handle = ipx_open_connection( &Node, 10, 0, 1 );	// SPX listener
					print( ", handle = %d", spx_handle );
					if ( spx_handle < 0 )
						spx_handle = -1;
					break;

				case '6':		// Establish an SPX  connection
					if ( spx_handle != -1 )
					{
						beep();
						break;
					}
					print( "\nEstablishing SPX connection ..." );
					Node.network = 0;
					Node.node[0] = 0;
					Node.node[1] = 0x80;
					Node.node[2] = 0xC8;
					Node.node[3] = 0x20;
					Node.node[4] = 0x5D;
					Node.node[5] = 0x73;
					Node.socket = 0x5352;
					spx_handle = ipx_open_connection( &Node, 10, 0, 3 );	// SPX establish
					print( ", handle = %d", spx_handle );
					if ( spx_handle < 0 )
						spx_handle = -1;
					break;

				default:
					break;
			}
			continue;
		}

/*
** Process any timer input
*/
		if ( Evt.type == EVT_TIMER )
		{
			print( ", time = %ld, vector = %08lX", Evt.time, Evt.timer.vector );
			continue;
		}

/*
** Process any network input
*/
		if ( Evt.type == EVT_NETWORK )
		{
			print( ", time = %ld, ECB = %08lX", Evt.time, Evt.network.ecb );
			print( "\nNode: %ls  flags=%02X, connection=%04X",
				addrtoa(buffer,Evt.network.ecb->immediateAddress), Evt.network.reason, Evt.network.connection );
			ipx_listen_packet( Evt.network.ecb );
			continue;
		}

/*
** Process any mouse input
*/
		if ( Evt.type == EVT_MOUSE )
		{
			print( ", x = %d, y = %d, state = %04X", Evt.mouse.x, Evt.mouse.y, Evt.mouse.state );
			if ( Evt.mouse.ascii == ESC )
				Main_Loop_Continue = 0;
			continue;
		}
	}
	print( "\nExiting this fine program" );
	ipx_stop();
	tmr_kill( Tmr1 );
	tmr_kill( Tmr2 );

	stop_events();
}

